package textanalyzer.model;

import java.awt.*;
import java.net.*;
import java.io.*;
import textanalyzer.model.knowledge.*;

public 
class   AppModel {
    
    // constructor
    
    public 
    AppModel( AppUI ui ) {
        this.ui = ui;
        properties = new Properties();
        resManager = new ResourceManager( this );
        agent = new KnowledgeAgent();
        
    }
    
    
    // Application UI
    private AppUI ui;
    protected
    AppUI getUI() {
        return ui;
    }
    
    // Resource Manager
    private ResourceManager resManager;
    public 
    ResourceManager
    getResourceManager() {
        return resManager;
    }
    
    // Knowledge Agent
    private KnowledgeAgent agent;
    
    public 
    AnalyzerModel addInteractiveAnalysis( AnalyzerUI ui ) {
        return agent.addInteractiveAnalysis( resManager, ui );
    }

    // Application properties
    protected Properties properties;
    public 
    Properties getProperties() {
        return properties;
    }
    
    public class Properties {
        public String    Name;
        public String    Version;
        public String    Author;
        // app icon location
		public String    Icon;
        // app interface font
        public Font      UIFont;   
        // app interface color ( RGB ) 
        public Color     UIColor;   
        // app background color ( RGB ) 
        public Color     UIBgColor;  
        // applet preferred size ( in pixels )
        public Dimension UISize;             
        // UI refresh rate ( frames per second )
        public int       UIRefreshRate = 20;    
        // graphics mode ( 1 - Graphics, 2 - Graphics2D )
        public int       UIGraphicsMode = 1; 
    }
    
}
