package textanalyzer.model.knowledge;

import java.util.Vector;
import textanalyzer.model.*;

public 
class KnowledgeAgent {
    
    private WordSystem knowledge;
    private Vector     workers;
    
    public 
    KnowledgeAgent() {
        knowledge = new WordSystem();
        workers   = new Vector();
    }
    
    protected
    WordSystem getKnowledge() {
        return knowledge;
    }
    
    
    public 
    AnalyzerModel addInteractiveAnalysis( ResourceManager mgr, AnalyzerUI ui ) {
        InteractiveTextAnalyzer a = new InteractiveTextAnalyzer( this, mgr, ui );
        addWorker( a );
        return (AnalyzerModel)a;
    }

 
    private 
    void addWorker( KnowledgeWorker worker ) {
        workers.addElement( worker );
        worker.start();
    }

    private 
    int countWorkers() {
        return workers.size();
    }
    
    private 
    KnowledgeWorker getWorker( int i ) {
        return (KnowledgeWorker)workers.elementAt( i );
    }
    
    protected
    synchronized
    void finishedWorker( KnowledgeWorker worker ) {
        workers.removeElement( worker );            
    }
    
    public 
    void loadState( String location ) {
    }
    
    public 
    void saveState( String location ) {
        // suspend workers
        for( int i=0; i<workers.size(); i++ ) {
            ( (KnowledgeWorker)workers.elementAt(i) ).suspend();
        }
        //knowledge.save();
        // resume workers
        for( int i=0; i<workers.size(); i++ ) {
            ( (KnowledgeWorker)workers.elementAt(i) ).resume();
        }
    }

}
