package textanalyzer.model.knowledge;

import java.util.StringTokenizer;

public 
abstract
class   TextParser 
extends KnowledgeWorker {
    
    private static final String 
        DELIMITERS  = " \n\r\t,;:.!?@#$%~^'`\"\\&|()[]{}*/-+=<>0123456789",
        WHITESPACE  = " \n\r\t",
        PUNCTUATION = ",;:.!?@#$%~^`\"\\&|()[]{}*/-+=<>",
        DIGITS      = "0123456789";
    
    
    protected WordOccuranceContext context;
    private   boolean punctuation;
    protected String  text;
    
    public 
    TextParser( KnowledgeAgent agent, boolean punctuation ) {
        super( agent );
        this.punctuation = punctuation;
        this.context     = new WordOccuranceContext();
    }
    
    public 
    TextParser( KnowledgeAgent agent ) {
        this( agent, false );
    }
    
    protected WordOccurance WO;
    public 
    void parse() {
        if ( text == null ) return;
        StringTokenizer t = new StringTokenizer( text, DELIMITERS, punctuation );
        String token;
        Word W;
        WO = null;
        WordOccurance prevWO = null;
        int distance = 0;
        //System.out.println( "\nParsing:" + text );
        int n = t.countTokens();
        int i = 0;
        while ( t.hasMoreTokens() ) {
            token = t.nextToken();
            if ( ++i == n ) { 
                // leave last word (it can be cutted)
                text = token;
            }
            if ( token.length() == 1 && 
                 WHITESPACE.indexOf(token) != -1 ) {
                 // Whitespace
                 distance++;
                 continue;
            }
            // new WordOccurance
            W  = knowledge.recognize( token.toLowerCase() );
            if (!W.stopword) {
                WO = new WordOccurance( prevWO, distance, W );
                prevWO = WO;
                distance = 0;
                context.incoming( WO );
            }
        }
    }
    

    //public abstract void newWordOccurance( WordOccurance SO );

    //public abstract void checkpoint( WordOccurance SO );
    
}
