package textanalyzer.model.knowledge;

import java.util.Hashtable;
import java.util.Enumeration;

/*  Words are
 *  basic Knowledge elements correlated with others 
 *  (WordCorrelation) and organized into network-like 
 *  structure ( WordSystem ) through WordRelation-s
 */

public 
class  Word {
    
    private String value;
    private int       ID;           // ID for serialization
    private Hashtable correlations;
    public boolean stopword = false;
    
    public 
    Word( String value ) {
        this.value = value;
        correlations = new Hashtable();
    }
    
    public 
    String value() {
        return value;
    }

    public 
    void setID( int ID ) { 
        this.ID = ID; 
    }

    public 
    int getID() { 
        return ID; 
    }
    
    public 
    WordCorrelation getCorrelation( Word S ) {
        WordCorrelation SC = (WordCorrelation)correlations.get( S );
        if ( SC == null ) {
            SC = new WordCorrelation();
            correlations.put( S, SC );
        }
        return SC;
    }

    public 
    Enumeration getCorrelates() {
        return correlations.keys();
    }

}
