package textanalyzer.model.knowledge;

class WordOccuranceContext {
    
    public static int DEFAULT_SIZE = 5; 
    protected int size;
    
    public 
    WordOccuranceContext( int size ) {
        this.size = size;
        L = (double)(size+1); // see below
        K = k*L;
    }

    public 
    WordOccuranceContext() {
        this( DEFAULT_SIZE );
    }
    
    public
    void incoming( WordOccurance SO ) {
        Word S = SO.getWord();
        int d = 0;
        // increase selfcorrelation (weight) of Word and 
        // its correlation with previous Word occurances 
        Word S1;
        while ( d < size && SO != null ) {
            S1 = SO.getWord();
            S1.getCorrelation(S).strengthen( f(d) );
            SO = SO.getPrevious();
            d++;
        }  
    }
    
    // correlation
    
    // correlation full decay factor, ( equals context size ) 
    private double L; 
    // peak strengthen factor k ( max{f} = K = k*L )
    private static double k = 1.0; 
    private double K; 

    // correlation function of d
    // d - distance from previous WordOccurance-s
    private 
    int f ( int d ) {
        int f = (int)Math.round( K*( 1 - d/L ) );
        if ( f < 0 ) f = 0;
        return f;
    }
    
}
