package textanalyzer.ui;

import java.awt.Toolkit;
import java.applet.Applet;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

class MainFrame extends Frame {

    MainApplet applet;
	
    public MainFrame( MainApplet applet ) {
		this.applet = applet;
        addKeyListener( applet );
        applet.frame = this;
		setTitle( applet.properties.Name );
		try {
			setIconImage( Toolkit.getDefaultToolkit().getImage( applet.properties.Icon ) );
		} catch( Exception e ) { 
            System.out.println( "cannot load image:" + applet.properties.Icon ); 
		}
		setSize( applet.properties.UISize );  
		add( "Center", applet );
		addWindowListener( new Adapter() );
		applet.init();
		applet.start();
		show();
    }
    
    public void addToTitle( String string ) {
        setTitle( applet.properties.Name + " - " + string );
    }

    class Adapter extends WindowAdapter {
        public void windowClosing(WindowEvent e) {
            applet.stop();
            applet.destroy();
            System.exit(0);
        }
    }

}