package textanalyzer.ui.view;

public class Activator implements Runnable {
	
	Active active;
	Thread refreshThread;
	int refreshDelay;
	
	public Activator( Active active ) {
		this.active = active;
		refreshDelay = 1000 / active.getRefreshRate();
	}
	
    public void run() {
		//Thread.currentThread().setPriority( Thread.MIN_PRIORITY );
        long startTime = System.currentTimeMillis();
		while ( Thread.currentThread() == refreshThread ) {
		    active.refresh();
			try {
				startTime += refreshDelay;
				Thread.sleep( Math.max( 0, startTime - System.currentTimeMillis() ) );
			} catch (InterruptedException e) {
				System.out.println( "! thread interrupted: " +  e.toString() );
				break;
			}
		}
    }
	
    public void start() {
        if( refreshThread == null )
            refreshThread = new Thread( this );
        refreshThread.start();
    }

    public void stop() {
       refreshThread = null;
    }

}
