package textanalyzer.ui.view.graph;

import textanalyzer.ui.*;
import textanalyzer.ui.view.*;
import java.awt.*;
import java.util.Enumeration;
import textanalyzer.model.*;

public 
class   GraphView 
extends View {

	GraphController controller;
    GraphModel model;
	GraphPainter painter;

	public GraphView( MainApplet applet ) {
		super( applet );
		model = new GraphModel();
		controller = new GraphController( model, this );
        addMouseListener( controller );
		if( applet.properties.UIGraphicsMode == 2 ) {
			try {
				Class x = Class.forName("java.awt.Graphics2D");
				//painter = new GraphPainter2( model );
			} catch( Exception e ) {
				System.out.println("cannot switch to Graphics2D mode: " + e.toString() );
				painter = new GraphPainter( model, this );
			}
		} else painter = new GraphPainter( model, this );
	}
	
	public 
    AnalyzerUI getModel() {
		return (AnalyzerUI)model;
	}
	
    public void scale( double scale ) {
        model.getModel().updateUI(scale);
    }
    
	Enumeration list;
	public synchronized void update( Graphics g ) {
        super.update( g );
		list = model.listEdges();
		while( list.hasMoreElements() ) {
			painter.paintEdge( offgraphics, (Edge)list.nextElement() );
		}
		list = model.listNodes();
		while( list.hasMoreElements() ) {
			Node node = (Node)list.nextElement();
			painter.paintNode( offgraphics, node );
		}
		g.drawImage( offscreen, 0, 0, null );
		model.refresh(); // !!!
		if ( model.root != null && model.picked == null ) {
			ModelPoint p = model.root.point;
			if ( p.x != point.x || p.y != point.y )	moveTowards(p);
		}
        super.changed = false;
    }
	
}
